<template>
  <b-container>
    <b-row>
      <b-col md="10">
        <b-card title="Statistics">
            <p>total objects: {{Object.keys(objects).length}}</p>
            <p>total classification: {{Object.keys(classifications).length}}</p>
        </b-card>
      </b-col>
      <b-col md="2">
        <b-card title="Tools">
          <b-button class="tool_button" @click="open_modal('crete_object_modal')"  variant="success">add object</b-button>
          <b-button class="tool_button" @click="open_modal('crete_classification_modal')"  variant="success">add classification</b-button>
          <b-modal :hide-footer=true ref="crete_object_modal" centered title="Create object">
            <AddObject @done_create_object="object_created" :classifications="classifications"></AddObject>
          </b-modal>

          <b-modal :hide-footer=true ref="crete_classification_modal" centered title="Create classification">
            <AddClassification @done_create_classification="classification_created"></AddClassification>
          </b-modal>

        </b-card>
      </b-col>
    </b-row>

  </b-container>

</template>

<script>
import axios from "axios";
import router from "@/router";
import Spinner from "@/views/Spinner";
import Authorization from "@/views/Authorization";
import AddObject from "@/views/AddObject";
import AddClassification from "@/views/AddClassification";

export default {
  name: "AdminPanel",
  components: {
    AddObject,
    AddClassification
  },
  data: function () {
    return {
      objects: {},
      classifications: {},
    }
  },
  mounted: function () {
    this.get_objects();
    this.get_classification();
  },
  methods: {

    get_objects: function () {
      axios({
        url: '/api/object/',
        method: 'get',

      }).then(response => {
        for (let i = 0; i < response.data.length; i++) {
          this.$set(this.objects, response.data[i]['id'], response.data[i]);
        }
      }).catch(error => {
        this.$root.make_notification(
            !error.response || error.response.status >= 500
                ? 'Something went wrong 🤷‍♀️'
                : error.response.data.reason,
            'Failed to get a list of objects')
        this.$emit('template_ready');
      });
    },
    get_classification: function () {
      axios({
        url: '/api/classification/',
        method: 'get',
      }).then(response => {
        for (let i = 0; i < response.data.length; i++) {
          this.$set(this.classifications, response.data[i]['id'], response.data[i]);
        }
      }).catch(error => {
        this.$root.make_notification(
            !error.response || error.response.status >= 500
                ? 'Something went wrong 🤷‍♀️'
                : error.response.data.reason,
            'Failed to get a list of objects')
        this.$emit('template_ready');
      });
    },
    classification_created: function (new_classification) {

      this.$set(this.classifications, new_classification.id, new_classification);
      this.close_modal('crete_classification_modal');
    },
    object_created: function (new_object) {
      this.$set(this.objects, new_object.id, new_object);
      this.close_modal('crete_object_modal');
    },
    template_ready: function () {
      this.$emit('template_ready');
    },
    template_load: function () {
      this.$emit('template_load');
    },
    close_modal: function (ref) {
      this.$refs[ref].hide();
    },
    open_modal: function (ref) {
      this.$refs[ref].show();
    },
  }
}
</script>

<style scoped>

.tool_button{
  margin-bottom: 10px;
}

</style>